import { jsx as _jsx } from "react/jsx-runtime";
import { EditorState } from "@codemirror/state";
import { EditorView } from "@codemirror/view";
import { useEffect, useRef } from "react";
import { recording, shortcuts } from "../extensions";
import { useBoothStore } from "../store";
/** CodeMirror editor. */
export function Editor(props) {
    const useStore = useBoothStore();
    const ref = useRef();
    useEffect(() => {
        var _a, _b;
        // get prefix (before we replace the DOM element)
        let prefix = "";
        if (ref.current.parentElement.getAttribute("role") === "tabpanel") {
            prefix = ref.current.parentElement.getAttribute("id").slice("panel-".length) + ":";
        }
        // create editor
        const view = new EditorView({
            state: EditorState.create({
                doc: (_a = props.content) !== null && _a !== void 0 ? _a : "",
                extensions: [
                    recording.of([]),
                    shortcuts.of([]),
                    ...(props.editable ? [EditorView.editable.of(false)] : []),
                    ...((_b = props.extensions) !== null && _b !== void 0 ? _b : [])
                ]
            })
        });
        ref.current.replaceWith(view.dom);
        useStore.setState(prev => {
            var _a, _b;
            const group = (_a = prev.groups[props.group]) !== null && _a !== void 0 ? _a : { activeFile: props.filename, files: [] };
            return {
                groups: Object.assign(Object.assign({}, prev.groups), { [props.group]: {
                        activeFile: group.activeFile,
                        files: [
                            ...group.files,
                            {
                                editable: (_b = props.editable) !== null && _b !== void 0 ? _b : true,
                                filename: props.filename,
                                view
                            }
                        ]
                    } })
            };
        });
    }, []);
    return (_jsx("div", { ref: ref }));
}
