var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { keymap } from "@codemirror/view";
import { passThrough } from "@lqv/codemirror/extensions";
import { CodeRecording } from "@lqv/codemirror/recording";
import { useKeymap } from "liqvid";
import { useEffect, useMemo } from "react";
import { recording } from "../extensions";
import { useBoothStore } from "../store";
import { Editor } from "./Editor";
/** Recording editor. */
export const Record = (props) => {
    const { captureKeys = ["Mod-Enter", "Mod-L"], extensions = [], passKeys = ["Mod-Alt-2", "Mod-Alt-3", "Mod-Alt-4"] } = props, attrs = __rest(props, ["captureKeys", "extensions", "passKeys"]);
    const useStore = useBoothStore();
    const lqvKeymap = useKeymap();
    const newExtensions = useMemo(() => {
        var _a;
        return [
            keymap.of(passThrough(lqvKeymap, passKeys)),
            ...((_a = props.extensions) !== null && _a !== void 0 ? _a : [])
        ];
    }, [passKeys]);
    // attach recording extensions --- this has to be done this way because
    // the `shortcuts` Compartment will abort further handling of the sequence
    useEffect(() => {
        const { view } = useStore.getState().groups[props.group].files.find(file => file.filename === props.filename);
        view.dispatch({
            effects: recording.reconfigure([
                recording.get(view.state),
                [CodeRecording.recorder.extension(captureKeys)]
            ])
        });
    }, []);
    return (_jsx(Editor, Object.assign({ content: props.content, extensions: newExtensions }, attrs)));
};
