/// <reference types="react" />
import { Text } from "@codemirror/state";
import { cmReplay } from "@lqv/codemirror";
import { Store } from "../store";
import { Editor } from "./Editor";
declare type ReplayParams = Parameters<typeof cmReplay>[0];
/**
 * Editor to replay recorded coding.
 */
export declare function Replay(props: {
    /**
     * Callback to handle special key sequences.
     * @param useStore The CodeBooth store.
     * @param key The key sequence that was pressed.
     * @param doc The CodeMirror document.
     */
    handle?: (useStore: Store, key: string, doc: Text) => void;
    /** Coding data to replay. */
    replay: ReplayParams["data"];
    /**
     * Time to start replaying.
     * @default 0
     */
    start?: number;
} & React.ComponentProps<typeof Editor>): JSX.Element;
export {};
