var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { drawSelection, ViewPlugin } from "@codemirror/view";
import { cmReplay, fakeSelection } from "@lqv/codemirror";
import { usePlayback } from "liqvid";
import { useCallback, useMemo } from "react";
import { useBoothStore } from "../store";
import { Editor } from "./Editor";
/**
 * Editor to replay recorded coding.
 */
export function Replay(props) {
    const useStore = useBoothStore();
    const playback = usePlayback();
    const { extensions = [], handle, replay, start } = props, attrs = __rest(props, ["extensions", "handle", "replay", "start"]);
    const __handle = useCallback((key, doc) => {
        if (handle) {
            handle(useStore, key, doc);
        }
    }, [handle]);
    const __extensions = useMemo(() => [
        ViewPlugin.define(fakeSelection(drawSelection())),
        ViewPlugin.define(view => {
            cmReplay({
                data: replay,
                handle: __handle,
                playback: playback,
                start: start !== null && start !== void 0 ? start : 0,
                view
            });
            return {};
        }),
        ...(extensions !== null && extensions !== void 0 ? extensions : [])
    ], [extensions, replay, start]);
    return _jsx(Editor, Object.assign({ editable: false, extensions: __extensions }, attrs));
}
