/// <reference types="react" />
/** Div to hold buttons. */
export declare const Buttons: React.FC;
/** Button for clearing the output/console. */
export declare function Clear(): JSX.Element;
/** Button for copying the contents of one buffer to another. */
export declare const Copy: React.FC<{
    from: string;
    to: string;
}>;
/** Button for resetting editor. */
export declare const Reset: React.FC<{
    to: Record<string, {
        files: {
            content: string;
            filename: string;
        }[];
    }>;
}>;
/** Button for running the code. */
export declare function Run(): JSX.Element;
/** Group selection tab. */
export declare const Tab: React.FC<{
    /** ID of {@link TabPanel} this corresponds to */
    id: string;
} & React.ButtonHTMLAttributes<HTMLButtonElement>>;
/** Holds a list of tabs. */
export declare const TabList: React.FC<React.HTMLAttributes<HTMLDivElement>>;
