import { createContext, useContext } from "react";
import create from "zustand";
import { subscribeWithSelector } from "zustand/middleware";
export const createStore = (state = {}) => create(subscribeWithSelector((set, get) => (Object.assign({ 
    // default values
    activeGroup: undefined, groups: {}, getActiveFiles() {
        const { activeGroup, editors } = get();
        const files = {};
        for (const key in editors) {
            if (key.startsWith(`${activeGroup}:`)) {
                const filename = key.slice(`${activeGroup}:`.length);
                files[filename] = editors[key].state.doc.toString();
            }
        }
        return files;
    }, messages: [], run: 0 }, state))));
export const BoothStore = createContext(null);
export function useBoothStore() {
    return useContext(BoothStore);
}
